# Chat server

Chat server provides means of communications for participants.

## How does it work?

At its base is websocket server implementation from Qt library `QWebSocketServer`. The class `ChatServer` acts as a sender and reciever in communication. When new message arrives it's added to the worker queue to be picked by worker thread. The class `Worker` represents just that. It has queue of messages from socket and they are processed by threadpool. The `DatabaseWrapper` then acts as a connection to persistent data like login details. It uses `QSqlDatabase` and sqlite as its backend.

## Run

```
$ ./server
Usage: ./server [options]

Options:
  -v, --version            Displays version information.
  -h, --help               Displays help on commandline options.
  --help-all               Displays help including Qt specific options.
  -t, --threads <threads>  Specify number of threads.
  -p, --port <port>        Specify server port.
  -d, --database_path <path>  Specify path to database.
```

After starting the binary, server will start listening on port 1234 (by default) for incoming connections. This can be altered with command line parameter `-p <port>`. Also by default, server will use only one thread for processing messages. Use option `-t <number>` to set number of threads for your situation. The path to database can be specified with `-d <path>` and if ommited, the database will be saved where the binary is.
